﻿<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta charset="utf-8" />
    <title>amCharts Test</title>

    <script src="https://www.amcharts.com/lib/3/amcharts.js"></script>
    <script src="https://www.amcharts.com/lib/3/serial.js"></script>
    <script src="https://www.amcharts.com/lib/3/plugins/export/export.min.js"></script>
    <script src="https://www.amcharts.com/lib/3/plugins/dataloader/dataloader.min.js"></script>
    <link rel="stylesheet" href="https://www.amcharts.com/lib/3/plugins/export/export.css" type="text/css" media="all" />
    <script src="https://www.amcharts.com/lib/3/themes/none.js"></script>
    <script src="https://www.amcharts.com/lib/3/themes/light.js"></script>
    <script src="https://www.amcharts.com/lib/3/themes/dark.js"></script>
    <script src="https://www.amcharts.com/lib/3/themes/black.js"></script>
    <script src="https://www.amcharts.com/lib/3/themes/chalk.js"></script>
    

    <script type="text/javascript">
        /**
         * Init some variables for demo purposes
         */
        var day = 0;
        var firstDate = new Date();
        firstDate.setDate(firstDate.getDate() - 500);

        /**
         * Function that generates random data
         */
        function generateChartData() {
            var chartData = [];
            for (day = 0; day < 50; day++) {
                var newDate = new Date(firstDate);
                newDate.setDate(newDate.getDate() + day);

                var base = 13500;
                var open;
                if (chartData.length > 0)
                    open = chartData[chartData.length - 1].close;
                else
                    open = Math.round(Math.random() * 100 + base);
                var high = Math.round(Math.random() * 100 + base);
                var low = Math.round(Math.random() * 100 + base);
                var close = Math.round(Math.random() * 100 + base);

                chartData.push({
                    "date": newDate,
                    "open": open,
                    "high": high,
                    "low": low,
                    "close": close
                });
            }
            return chartData;
        }

        function generateChartData2(msg) {
            alert(msg[0][0][0]);

            var chartData = [];
            // var parsed = JSON.parse(msg);   // <--
            var json = JSON.stringify(msg);
            alert(json);

            var newDate;
            var open;
            var high;
            var low;
            var close;

            for (var x in parsed) {
                day++;
                var newDate = new Date(firstDate);
                newDate.setDate(newDate.getDate() + day);
                open = x[1];
                high = x[2];
                low = x[3];
                close = x[4];

                chartData.push({
                    "date": newDate,
                    "open": open,
                    "high": high,
                    "low": low,
                    "close": close
                });
            }

            chart.dataProvider = chartData;
        }

        var chart = AmCharts.makeChart("chartdiv", {
            "type": "serial",
            "theme": "light",
            // "theme": "Chalk",
            // "dataDateFormat":"YYYY-MM-DD",
            "valueAxes": [ {
                "position": "left"
            } ],
            "graphs": [ {
                "id": "g1",
                "balloonText": "Open:<b>[[open]]</b><br>Low:<b>[[low]]</b><br>High:<b>[[high]]</b><br>Close:<b>[[close]]</b><br>",
                "closeField": "close",
                "fillColors": "#15b723",
                "highField": "high",
                "lineColor": "#15b723",
                "lineAlpha": 1,
                "lowField": "low",
                "fillAlphas": 0.9,
                "negativeFillColors": "#ea3333",
                "negativeLineColor": "#ea3333",
                "openField": "open",
                "title": "Price:",
                "type": "candlestick",
                "valueField": "close"
            } ],
            "chartScrollbar": {
                "graph": "g1",
                "graphType": "line",
                "scrollbarHeight": 30,
                "autoGridCount": true
            },
            "chartCursor": {
                "cursorPosition": "mouse",
                "valueLineEnabled": true,
                "valueLineBalloonEnabled": true
            },
            // "dataProvider": chartData,
            // "dataProvider": generateChartData(),
            "categoryField": "date",
            "categoryAxis": {
                "parseDates": true,
                "minPeriod": "DD",
                "dashLength": 1,
                "gridAlpha": 0.15,
                "axisColor": "#DADADA"
            },
            "export": {
                "enabled": true,
                "position": "bottom-right"
            }
        });

        // 控制 zoom in/out
        AmCharts.addListener("rendered", zoomChart);
        zoomChart();

        function zoomChart() {
            // different zoom methods can be used - zoomToIndexes, zoomToDates, zoomToCategoryValues
            chart.zoomToIndexes(chart.dataProvider.length - 10, chart.dataProvider.length - 1);
        }

    </script>

    <script type="text/javascript">

        // 深度圖
        var chart2 = AmCharts.makeChart("chartdiv2", {
            "type": "serial",
            "theme": "none",
            "dataLoader": {
                // "url": "https://www.amcharts.com/wp-content/uploads/assets/data/poloniex.php?x=iklp5a",
                // "url": "http://localhost:1337/kraken_order_book",
                "url": "http://localhost:1337/bitfinex_order_book",
                "format": "json",
                "reload": 2,
                "postProcess": function (data) {

                    // Function to process (sort and calculate cummulative volume)
                    function processData(list, type, desc) {

                        // Convert to data points
                        for (var i = 0; i < list.length; i++) {
                            list[i] = {
                                value: Number(list[i][0]),
                                volume: Number(list[i][1]),
                            }
                        }

                        // Sort list just in case
                        list.sort(function (a, b) {
                            if (a.value > b.value) {
                                return 1;
                            }
                            else if (a.value < b.value) {
                                return -1;
                            }
                            else {
                                return 0;
                            }
                        });

                        // Calculate cummulative volume
                        if (desc) {
                            for (var i = list.length - 1; i >= 0; i--) {
                                if (i < (list.length - 1)) {
                                    list[i].totalvolume = list[i + 1].totalvolume + list[i].volume;
                                }
                                else {
                                    list[i].totalvolume = list[i].volume;
                                }
                                var dp = {};
                                dp["value"] = list[i].value;
                                dp[type + "volume"] = list[i].volume;
                                dp[type + "totalvolume"] = list[i].totalvolume;
                                res.unshift(dp);
                            }
                        }
                        else {
                            for (var i = 0; i < list.length; i++) {
                                if (i > 0) {
                                    list[i].totalvolume = list[i - 1].totalvolume + list[i].volume;
                                }
                                else {
                                    list[i].totalvolume = list[i].volume;
                                }
                                var dp = {};
                                dp["value"] = list[i].value;
                                dp[type + "volume"] = list[i].volume;
                                dp[type + "totalvolume"] = list[i].totalvolume;
                                res.push(dp);
                            }
                        }

                    }

                    // Init
                    var res = [];
                    processData(data.bids, "bids", true);
                    processData(data.asks, "asks", false);

                    //console.log(res);
                    return res;
                }
            },
            "graphs": [{
                "id": "bids",
                "fillAlphas": 0.1,
                "lineAlpha": 1,
                "lineThickness": 2,
                "lineColor": "#0f0",
                "type": "step",
                "valueField": "bidstotalvolume",
                "balloonFunction": balloon
            }, {
                "id": "asks",
                "fillAlphas": 0.1,
                "lineAlpha": 1,
                "lineThickness": 2,
                "lineColor": "#f00",
                "type": "step",
                "valueField": "askstotalvolume",
                "balloonFunction": balloon
            }, {
                "lineAlpha": 0,
                "fillAlphas": 0.2,
                "lineColor": "#000",
                "type": "column",
                "clustered": false,
                "valueField": "bidsvolume",
                "showBalloon": false
            }, {
                "lineAlpha": 0,
                "fillAlphas": 0.2,
                "lineColor": "#000",
                "type": "column",
                "clustered": false,
                "valueField": "asksvolume",
                "showBalloon": false
            }],
            "categoryField": "value",
            "chartCursor": {},
            "balloon": {
                "textAlign": "left"
            },
            "valueAxes": [{
                "title": "Volume"
            }],
            "categoryAxis": {
                "title": "Price (BTC/USD)",
                "minHorizontalGap": 100,
                "startOnAxis": true,
                "showFirstLabel": false,
                "showLastLabel": false
            },
            "export": {
                "enabled": true,
                "position": "bottom-right"
            }
        });

        function balloon(item, graph) {
            var txt;
            if (graph.id == "asks") {
                txt = "Ask: <strong>" + formatNumber(item.dataContext.value, graph.chart, 4) + "</strong><br />"
                  + "Total volume: <strong>" + formatNumber(item.dataContext.askstotalvolume, graph.chart, 4) + "</strong><br />"
                  + "Volume: <strong>" + formatNumber(item.dataContext.asksvolume, graph.chart, 4) + "</strong>";
            }
            else {
                txt = "Bid: <strong>" + formatNumber(item.dataContext.value, graph.chart, 4) + "</strong><br />"
                  + "Total volume: <strong>" + formatNumber(item.dataContext.bidstotalvolume, graph.chart, 4) + "</strong><br />"
                  + "Volume: <strong>" + formatNumber(item.dataContext.bidsvolume, graph.chart, 4) + "</strong>";
            }
            return txt;
        }

        function formatNumber(val, chart2, precision) {
            return AmCharts.formatNumber(
              val,
              {
                  precision: precision ? precision : chart2.precision,
                  decimalSeparator: chart2.decimalSeparator,
                  thousandsSeparator: chart2.thousandsSeparator
              }
            );
        }
    </script>
</head>
<body>
    <!-- <script type="text/javascript" src="https://unpkg.com/ccxt"></script>
    <script src="http://localhost:1337/ccxt.js"></script>
    <script>run_ccxt();</script> -->

    <script src="/socket.io/socket.io.js"></script>
    <script>
        var socket = io();
        // socket.emit('message', "hello!");

        socket.on('OHLCV', function (msg) {
            // alert(msg['open'] + " " + msg['high'] + " " + msg['low'] + " " + msg['last']);
            generateChartData2(msg);
        });

        var interval = 0;
        socket.on('ticker', function (msg) {
            // alert(msg['open'] + " " + msg['high'] + " " + msg['low'] + " " + msg['last']);
            doValidate(msg);
        });

        function doValidate(msg) {
            if (interval++ > 4) {
                interval = 0;
                // remove datapoint from the beginning
                chart.dataProvider.shift();

                // add new one at the end
                day++;
                var newDate = new Date(firstDate);
                newDate.setDate(newDate.getDate() + day);
                var open = chart.dataProvider[chart.dataProvider.length - 1].close;
                var high = open;
                var low = open;
                var close = open;

                chart.dataProvider.push({
                    date: newDate,
                    open: open,
                    high: high,
                    low: low,
                    close: close
                });
            }
            else {
                var close = msg['last'];

                chart.dataProvider[chart.dataProvider.length - 1].close = close;
                if (close > chart.dataProvider[chart.dataProvider.length - 1].high)
                    chart.dataProvider[chart.dataProvider.length - 1].high = msg['last'];
                if (close < chart.dataProvider[chart.dataProvider.length - 1].low)
                    chart.dataProvider[chart.dataProvider.length - 1].low = msg['last'];
            }
            chart.validateData();
        };
    </script>
    

    <div id="chartdiv" style="width: 480px; height: 360px";></div>
    <div id="chartdiv2" style="width: 480px; height: 320px" ;></div>
</body>
</html>